Index: /other-projects/is-sheet-music-encore/trunk/image-identification-dev-02/image-identification-development/src/MainMorph.java
===================================================================
--- /other-projects/is-sheet-music-encore/trunk/image-identification-dev-02/image-identification-development/src/MainMorph.java	(revision 33588)
+++ /other-projects/is-sheet-music-encore/trunk/image-identification-dev-02/image-identification-development/src/MainMorph.java	(revision 33589)
@@ -66,4 +66,5 @@
 
 import static org.opencv.core.Core.FILLED;
+import static org.opencv.core.Core.calcCovarMatrix;
 import static org.opencv.core.CvType.CV_8UC3;
 import static org.opencv.highgui.HighGui.createJFrame;
@@ -193,5 +194,4 @@
             //Variables
             System.out.println("Running Code version: " + CODE_VERSION + " Image Version: " +IMAGE_VERSION);
-            Mat mid = new Mat();
             Mat edgesDetectedRGB = new Mat();
             Mat clustersFoundRGB = new Mat();
@@ -209,4 +209,5 @@
             //String default_file =hiresDirectory+"BK/NotSheetMusic/aeu.ark+=13960=t2q53nq6w-6.png";
             //String default_file =hiresDirectory+"BK/NotSheetMusic/aeu.ark+=13960=t9z03w65z-4.png";
+            //String default_file =hiresDirectory+"BK/NotSheetMusic/loc.ark+=13960=t50g4443d-5.png";
             //String default_file =hiresDirectory+"MU/NotSheetMusic/aeu.ark+=13960=t0dv28v9r-1.png";
             //String default_file =hiresDirectory+"MU/SheetMusic/emu.010001066823-9.png";
@@ -234,6 +235,7 @@
             //String default_file = hiresDirectory+"/MU/NotSheetMusic/aeu.ark+=13960=t0dv28v9r-1.png";  //Image evaluation
             //String default_file = hiresDirectory+"/MU/NotSheetMusic/aeu.ark+=13960=t0dv28v9r-2.png";  //large numbers
+            //String default_file = hiresDirectory+ "MU/SheetMusic/mdp.39015096400919-9.png";
             //String default_file = hiresDirectory+"/MU/NotSheetMusic/aeu.ark+=13960=t0dv28v9r-3.png";
-            String default_file = hiresDirectory+"/MU/SheetMusic/mdp.39015080921409-9.png";
+            //String default_file = hiresDirectory+"/MU/SheetMusic/mdp.39015080921409-9.png";
             //String default_file = hiresDirectory+"/MU/NotSheetMusic/aeu.ark+=13960=t0dv28v9r-4.png";
             //String default_file = hiresDirectory+"/MU/NotSheetMusic/aeu.ark+=13960=t0dv28v9r-5.png";
@@ -242,4 +244,5 @@
             //String default_file = hiresDirectory+"/MU/NotSheetMusic/aeu.ark+=13960=t0dv28v9r-8.png";
             //String default_file = hiresDirectory+"/MU/NotSheetMusic/aeu.ark+=13960=t0dv28v9r-9.png";
+            String default_file = hiresDirectory+"/MU/SheetMusic/mdp.39015096398899-4.png";
 
 
@@ -260,10 +263,54 @@
             Mat original = Imgcodecs.imread(filename, Imgcodecs.IMREAD_GRAYSCALE);
             System.out.println("Width: " + original.width() + " Height: " + original.height());
-            Mat binarizedOriginal = original.clone();
+            Mat binarized = original.clone();
             
-            Imgproc.adaptiveThreshold(original, binarizedOriginal,255, Imgproc.ADAPTIVE_THRESH_GAUSSIAN_C,Imgproc.THRESH_BINARY_INV, 15, THRESHOLD_C);
+            //Imgproc.adaptiveThreshold(original, binarized,255, Imgproc.ADAPTIVE_THRESH_GAUSSIAN_C,Imgproc.THRESH_BINARY_INV, 15, THRESHOLD_C);
             //TEST PARAMETERSImgproc.adaptiveThreshold(original, edgesDetected,255, Imgproc.ADAPTIVE_THRESH_GAUSSIAN_C,Imgproc.THRESH_BINARY_INV, 531,1);
             //Imgproc.threshold(original,original, 127, 255, Imgproc.THRESH_BINARY);
-
+            //************************
+            //Argument Setup
+            //************************
+            int tempvariable = 0;
+            if (tempvariable ==1){
+                Imgproc.adaptiveThreshold(original, binarized, 255, Imgproc.ADAPTIVE_THRESH_GAUSSIAN_C, Imgproc.THRESH_BINARY_INV, 1001, 5);
+            }
+            else {
+
+                int borderIgnoreAmount = 0;
+                double divisor;
+                switch (borderIgnoreAmount) {
+                    case 5:
+                        divisor = 40;
+                        break;
+                    case 10:
+                        divisor = 20;
+                        break;
+                    case 20:
+                        divisor = 10;
+                        break;
+                    case 40:
+                        divisor = 5;
+                        break;
+                    case 0:
+                        divisor = -1;
+                        break;
+                    default:
+                        divisor = -1;
+                }
+                if (divisor != -1) {
+                    Mat mid = new Mat();
+                    Imgproc.adaptiveThreshold(original, mid, 255, Imgproc.ADAPTIVE_THRESH_GAUSSIAN_C, Imgproc.THRESH_BINARY_INV, 15, THRESHOLD_C);
+                    double maxX = mid.size().width;
+                    double maxY = mid.size().height;
+                    Point cp1 = new Point(maxX / divisor, maxY / divisor);
+                    Point cp2 = new Point(maxX - cp1.x, maxY - cp1.y);
+                    Rect rectCrop = new Rect(cp1, cp2);
+                    binarized = mid.submat(rectCrop);
+                } else {
+                    Imgproc.adaptiveThreshold(original, binarized, 255, Imgproc.ADAPTIVE_THRESH_GAUSSIAN_C, Imgproc.THRESH_BINARY_INV, 15, THRESHOLD_C);
+                }
+
+                System.out.println("Width: " + binarized.width() + " Height: " + binarized.height());
+            }
 
             //****************MORPHOLOGY****************************************************************************************
@@ -276,6 +323,6 @@
             //dynamic morphology??
             if(CODE_VERSION == 1) {
-                int hori = binarizedOriginal.width();
-                int vert = binarizedOriginal.height();
+                int hori = binarized.width();
+                int vert = binarized.height();
                 //Find ratio between 100 and width and 100 and height
                 int divX = hori/10;
@@ -284,5 +331,5 @@
                 int sizeY = (vert/divY) * 10;
 
-                Mat test = binarizedOriginal.clone();
+                Mat test = binarized.clone();
                 imageViewer("Original", test);
 
@@ -326,5 +373,5 @@
 
                 //MAKE SURE BLACK & WHITE
-                Mat test = binarizedOriginal.clone();
+                Mat test = binarized.clone();
                 imageViewer("00 Binarized Original", test);
 
@@ -366,6 +413,6 @@
             //Tutorial/Demo Code
             if (CODE_VERSION == 3) {
-                Mat horizontal = binarizedOriginal.clone();
-                Mat vertical = binarizedOriginal.clone();
+                Mat horizontal = binarized.clone();
+                Mat vertical = binarized.clone();
                 // Specify size on horizontal axis
                 int horizontal_size = horizontal.cols() / 50;
@@ -420,6 +467,6 @@
                 imageViewer("original", original);
 
-                Mat test = binarizedOriginal.clone();
-                Mat pre = binarizedOriginal.clone();
+                Mat test = binarized.clone();
+                Mat pre = binarized.clone();
                 Mat dst = new Mat();
 
@@ -534,6 +581,6 @@
             //Better morphology attempt - dynamic
             if(CODE_VERSION == 5) {
-                int hori = binarizedOriginal.width();
-                int vert = binarizedOriginal.height();
+                int hori = binarized.width();
+                int vert = binarized.height();
                 //Find ratio between 100 and width and 100 and height
                 int sizeX100 = 10 * (hori/68);
@@ -551,5 +598,5 @@
                 imageViewer("original", original);
 
-                Mat test = binarizedOriginal.clone();
+                Mat test = binarized.clone();
                 imageViewer("00 Inverse Binarized Original", test);
 
@@ -643,6 +690,6 @@
                 imageViewer("original", original);
 
-                Mat src = binarizedOriginal.clone();
-                Mat test = binarizedOriginal.clone();
+                Mat src = binarized.clone();
+                Mat test = binarized.clone();
                 Mat mask = new Mat();
                 Mat dst = new Mat();
@@ -729,5 +776,5 @@
                 imageViewer("original", original);
 
-                Mat test = binarizedOriginal.clone();
+                Mat test = binarized.clone();
 
 
@@ -738,5 +785,5 @@
                 //Large Object Removal
                 //************************************
-                Mat srcLOR = binarizedOriginal.clone();
+                Mat srcLOR = binarized.clone();
                 Mat maskLOR = new Mat();
                 Mat dstLOR = new Mat();
@@ -968,9 +1015,9 @@
                     //Imgproc.adaptiveThreshold(original1, original,255, Imgproc.ADAPTIVE_THRESH_GAUSSIAN_C,Imgproc.THRESH_BINARY_INV, 15, THRESHOLD_C);
 
-                    Mat test = binarizedOriginal.clone();
+                    Mat test = binarized.clone();
                     //************************************
                     //Large Object Removal
                     //************************************
-                    Mat srcLOR = binarizedOriginal.clone();
+                    Mat srcLOR = binarized.clone();
                     Mat maskLOR = new Mat();
                     Mat dstLOR = new Mat();
@@ -1158,7 +1205,8 @@
             //Reset after david chat
             if(CODE_VERSION == 9){
+                int areaCounter=0;
                 //Display Original
                 imageViewer("original", original);
-                imageViewer("000 Inverse Binarized Original", binarizedOriginal);
+                imageViewer("000 Inverse Binarized Original", binarized);
 
 
@@ -1166,5 +1214,5 @@
                 //1. Large Object Remover
                 //************************************
-                Mat srcLOR = binarizedOriginal.clone();
+                Mat srcLOR = binarized.clone();
                 Mat maskLOR = new Mat();
                 Mat dstLOR = new Mat();
@@ -1176,10 +1224,10 @@
 
                 //Heal the large items
-                Mat healLOR = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(25,25));
+                Mat healLOR = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(25,25)); //5,5
                 Imgproc.morphologyEx(maskLOR,maskLOR, Imgproc.MORPH_CLOSE, healLOR);
                 imageViewer("002 heal objects in mask", maskLOR);
 
                 //IsolateLarge
-                Mat isolateLargeLOR = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(30,30));
+                Mat isolateLargeLOR = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(30,30)); //8,8
                 Imgproc.morphologyEx(maskLOR,maskLOR, Imgproc.MORPH_OPEN, isolateLargeLOR);
                 imageViewer("003 Isolate large", maskLOR);
@@ -1254,10 +1302,10 @@
 
                 //4. Classify like line clusters.
-                Mat base = binarizedOriginal.clone();
+                Mat base = binarized.clone();
                 //***********************************
                 //3. Isolate straight lines
                 //***********************************
                 //Heal lines
-                Mat healISL = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(82,1));
+                Mat healISL = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(86,1));
                 Imgproc.morphologyEx(dstLOR,base, Imgproc.MORPH_OPEN, healISL);
                 imageViewer("202 heal objects in mask", base);
@@ -1310,4 +1358,5 @@
                         System.out.println("i:"+ i + " Height: " + boundRect[i].height);
                         if(boundRect[i].width > 300){
+                            areaCounter++;
                             System.out.println("i:"+ i + " Width: " +  boundRect[i].width);
                             Imgproc.rectangle(rectOutput, boundRect[i].tl(), boundRect[i].br(), new Scalar(255, 0, 0), 20);
@@ -1318,4 +1367,5 @@
 
                 imageViewer("4000 Rect found", rectOutput);
+                System.out.println(areaCounter);
 
 
@@ -1327,12 +1377,28 @@
                 Pair returnVariables = new Pair();
                 int areaCounter=0;
+
+
                 //Mat original = Imgcodecs.imread(filename, Imgcodecs.IMREAD_GRAYSCALE);
-                //Mat binarizedOriginal = original.clone();
-                //Imgproc.adaptiveThreshold(original, binarizedOriginal,255, Imgproc.ADAPTIVE_THRESH_GAUSSIAN_C,Imgproc.THRESH_BINARY_INV, 15, THRESHOLD_C);
+                //Mat binarized = original.clone();
+                //Mat mid = new Mat();
+                //if(borderCrop > 0){
+                    //Imgproc.adaptiveThreshold(original, mid,255, Imgproc.ADAPTIVE_THRESH_GAUSSIAN_C,Imgproc.THRESH_BINARY_INV, 15, 2);
+                    //double maxX = mid.size().width;
+                    //double maxY = mid.size().height;
+                    //Point cp1 = new Point(maxX/10, maxY/10);
+                    //Point cp2 = new Point(maxX - cp1.x, maxY -cp1.y);
+                    //Rect rectCrop = new Rect(cp1, cp2);
+                    //binarized = mid.submat(rectCrop);
+                //}
+                //else{
+                //Imgproc.adaptiveThreshold(original, binarized,255, Imgproc.ADAPTIVE_THRESH_GAUSSIAN_C,Imgproc.THRESH_BINARY_INV, 15, THRESHOLD_C);
+                //}
+
+
                 try{
                     //************************************
                     //1. Large Object Remover
                     //************************************
-                    Mat srcLOR = binarizedOriginal.clone();
+                    Mat srcLOR = binarized.clone();
                     Mat maskLOR = new Mat();
                     Mat dstLOR = new Mat();
@@ -1353,5 +1419,5 @@
                     srcLOR.copyTo(dstLOR, maskLOR);
 
-                    Mat base = binarizedOriginal.clone();
+                    Mat base = binarized.clone();
                     //***********************************
                     //3. Isolate straight lines
Index: /other-projects/is-sheet-music-encore/trunk/image-identification-development/Makefile~
===================================================================
--- /other-projects/is-sheet-music-encore/trunk/image-identification-development/Makefile~	(revision 33589)
+++ /other-projects/is-sheet-music-encore/trunk/image-identification-development/Makefile~	(revision 33589)
@@ -0,0 +1,7 @@
+#https://www.tensorflow.org/install/lang_java
+
+run-Classifier01:
+	java -cp /Scratch/cpb16/opencv-3.4.2/build/bin/opencv-342.jar -Djava.library.path=/Scratch/cpb16/opencv-3.4.2/build/lib/ terminalImageId
+
+
+
Index: /other-projects/is-sheet-music-encore/trunk/image-identification-development/backup/MainBackup.java
===================================================================
--- /other-projects/is-sheet-music-encore/trunk/image-identification-development/backup/MainBackup.java	(revision 33589)
+++ /other-projects/is-sheet-music-encore/trunk/image-identification-development/backup/MainBackup.java	(revision 33589)
@@ -0,0 +1,188 @@
+import org.opencv.core.*;
+import org.opencv.core.Point;
+import org.opencv.highgui.HighGui;
+import org.opencv.imgcodecs.Imgcodecs;
+import org.opencv.imgproc.Imgproc;
+import static org.opencv.imgcodecs.Imgcodecs.imwrite;
+import java.awt.image.BufferedImage;
+import java.awt.image.DataBufferByte;
+import java.io.File;
+import javax.imageio.ImageIO;
+
+//REFERENCES:
+//https://docs.opencv.org/3.4.3/d9/db0/tutorial_hough_lines.
+//https://stackoverflow.com/questions/43443309/count-red-pixel-in-a-given-image
+//https://www.wikihow.com/Calculate-Percentage-in-Java
+//https://riptutorial.com/opencv/example/21963/converting-an-mat-object-to-an-bufferedimage-object
+
+
+
+//GOAL for 21st
+
+
+//Classifier 01
+//Have args so can call "java image-identification-classifier01 XX XX"
+//args can be parameters in algorthim such as threshold or theta?
+//Run on 5000 images.
+//Record success rates
+//All done with makefile
+
+
+//But first understand houghline transform
+//Know what the algorithm being used is doing.
+//MAke constants for this classifier
+//Make java be able to run on CMD line
+
+public class MainBackup {
+
+    //GLOBAL_CONSTANTS
+    //SHOULD TURN INTO ARGS
+
+    private static  BufferedImage toBufferedImage(Mat mat){
+        //MOSTLY COPY PASTE!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+        //MOSTLY COPY PASTE!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+        //https://riptutorial.com/opencv/example/21963/converting-an-mat-object-to-an-bufferedimage-object
+        try{
+            int type = BufferedImage.TYPE_3BYTE_BGR;
+            int bufferSize = mat.channels() * mat.cols() * mat.rows();
+            byte[] b = new byte[bufferSize];
+            //get all the pixels
+            mat.get(0, 0, b);
+            BufferedImage image = new BufferedImage(mat.cols(), mat.rows(), type);
+            final byte[] targetPixels = ((DataBufferByte) image.getRaster().getDataBuffer()).getData();
+            System.arraycopy(b, 0, targetPixels, 0, b.length);
+            return image;
+        }
+        catch(Exception e){
+            System.err.println(e);
+        }
+        return null;
+    }
+
+    private static boolean Classifier(BufferedImage img){
+        try {
+            //Read file
+            //BufferedImage img = ImageIO.read(new File(processedFile));
+            int x = img.getWidth();
+            int y = img.getHeight();
+            int pixelCount  = 0;
+            int redCount    = 0;
+            float percentage = 0;
+
+            //Go Thru every pixel
+            for(int i=0; i < y; i++){
+                for(int j=0;j < x; j++){
+                    //Get value for current pixels RGB value
+                    int currPixelRGB = img.getRGB(j, i);
+                    //Check if pixel is red (hex value of red)
+                    if(currPixelRGB == 0xFFFF0000){
+                        redCount++;
+                    }
+                    pixelCount++;
+                }
+            }
+            //Calculate percentage of Red in image
+            percentage = ((float)redCount/(float)pixelCount)*(float)100;
+            //If more than %10 and less than %50 then its sheet music!
+            if(percentage > 10 && percentage < 50){ //MAKE THESE CONSTANTS!!
+                return true;}
+        }
+        catch (Exception e) {
+            System.err.println(e);
+        }
+        return false;
+    }
+
+    public static void main(String[] args) {
+        System.loadLibrary(Core.NATIVE_LIBRARY_NAME);
+        try {
+            //Variables
+            Mat edgesDetected = new Mat();
+            Mat edgesDetectedRGB = new Mat();
+            Mat edgesDetectedRGBProb;
+            Mat justEdges; //TESTING
+            String default_file = "TestImages/houghlineTest.png";
+            String filename = ((args.length > 0) ? args[0] : default_file);
+
+            // Load an image
+            Mat original = Imgcodecs.imread(filename, Imgcodecs.IMREAD_GRAYSCALE);
+            // Edge detection
+            //Imgproc.Canny(original, edgesDetected, 50, 200, 3, false);
+            Imgproc.adaptiveThreshold(original, edgesDetected,255, Imgproc.ADAPTIVE_THRESH_GAUSSIAN_C,Imgproc.THRESH_BINARY,15, 2);
+            //Copy edges to the images that will display the results in BGR
+            Imgproc.cvtColor(edgesDetected, edgesDetectedRGB, Imgproc.COLOR_GRAY2BGR);
+            edgesDetectedRGBProb = edgesDetectedRGB.clone();
+
+            justEdges = edgesDetectedRGBProb.clone();//TESTING
+
+            // Standard Hough Line Transform
+            Mat lines = new Mat(); // will hold the results of the detection
+            //(edgeDetectedImage, outputOfDetection(r,Îž), resolution of r, resolution of Îž, threshold (minimum num of intersections)
+            Imgproc.HoughLines(edgesDetected, lines, 1, Math.PI / 180.0, 150); // runs the actual detection
+
+            //Draw the lines
+            //LOOK OVER THIS AGAIN THE 1000 might be image height?
+            //THRESHOLD should be changed, based on img dimensions?
+
+            //make some test images. black and white. row of white row of black. call hough transform. check if its displaying as expected
+            //make sure res of 0 is appropriate, try 360
+            //expect theta values of 0+-
+            //try greyscale image
+
+            for (int x = 0; x < lines.rows(); x++) {
+                double rho = lines.get(x, 0)[0],
+                        theta = lines.get(x, 0)[1];
+                //CONVERT to Cartisean coord
+                double a = Math.cos(theta), b = Math.sin(theta);
+                double x0 = a * rho, y0 = b * rho;
+
+                Point pt1 = new Point(Math.round(x0 + 1000 * (-b)), Math.round(y0 + 1000 * (a)));
+                Point pt2 = new Point(Math.round(x0 - 1000 * (-b)), Math.round(y0 - 1000 * (a)));
+                Imgproc.line(edgesDetectedRGB, pt1, pt2, new Scalar(0, 0, 255), 3, Imgproc.LINE_AA, 0);
+            }
+
+
+            /*
+            // Probabilistic Line Transform
+            Mat linesP = new Mat(); // will hold the results of the detection
+            Imgproc.HoughLinesP(edgesDetected, linesP, 1, Math.PI / 180, 50, 50, 10); // runs the actual detection
+            // Draw the lines
+            for (int x = 0; x < linesP.rows(); x++) {
+                double[] l = linesP.get(x, 0);
+                Imgproc.line(edgesDetectedRGBProb, new Point(l[0], l[1]), new Point(l[2], l[3]), new Scalar(0, 0, 255), 3, Imgproc.LINE_AA, 0);
+            }
+
+            //Convert MAT into a BufferedImage
+            BufferedImage toBeClassifiedImg = toBufferedImage(edgesDetectedRGBProb);
+
+            //Calculate if its sheet music or not
+            Boolean isSheetMusic = Classifier(toBeClassifiedImg);
+            System.out.println("Filename: " + filename + "  Status: " + isSheetMusic);
+
+            //Save Processed Image
+            String processedFile = null;
+            if (isSheetMusic == true) {
+                //NEED FIGURE OUT HOW RUN IN SCRIPT. THEN USE ARGS as filename + "HoughLineP + "png"
+                processedFile = "SheetMusic/Test_HoughLineP.png";
+            }else {
+                processedFile = "Test_HoughLineP.png";
+            }
+            imwrite(processedFile, edgesDetectedRGBProb);
+            */
+
+
+            //Display Results
+            //HighGui.imshow("Source", original);
+            HighGui.imshow("Just Edges", justEdges); //TESTING
+            HighGui.imshow("Detected Lines (in red) - Standard Hough Line Transform", edgesDetectedRGB);
+            //HighGui.imshow("Detected Lines (in red) - Probabilistic Line Transform", edgesDetectedRGBProb);
+
+            // Wait and Exit
+            HighGui.waitKey();
+            System.exit(0);
+        }
+        catch(Exception e){
+            System.err.println(e);
+        }
+    }
+}
Index: /other-projects/is-sheet-music-encore/trunk/image-identification-development/backup/MainHoughLine.java
===================================================================
--- /other-projects/is-sheet-music-encore/trunk/image-identification-development/backup/MainHoughLine.java	(revision 33589)
+++ /other-projects/is-sheet-music-encore/trunk/image-identification-development/backup/MainHoughLine.java	(revision 33589)
@@ -0,0 +1,196 @@
+import org.opencv.core.*;
+import org.opencv.core.Point;
+import org.opencv.highgui.HighGui;
+import org.opencv.imgcodecs.Imgcodecs;
+import org.opencv.imgproc.Imgproc;
+import static org.opencv.imgcodecs.Imgcodecs.imwrite;
+import java.awt.image.BufferedImage;
+import java.awt.image.DataBufferByte;
+import java.io.File;
+import javax.imageio.ImageIO;
+
+//REFERENCES:
+//https://docs.opencv.org/3.4.3/d9/db0/tutorial_hough_lines.
+//https://stackoverflow.com/questions/43443309/count-red-pixel-in-a-given-image
+//https://www.wikihow.com/Calculate-Percentage-in-Java
+//https://riptutorial.com/opencv/example/21963/converting-an-mat-object-to-an-bufferedimage-object
+
+
+
+//GOAL for 21st
+
+
+//Classifier 01
+//Have args so can call "java image-identification-classifier01 XX XX"
+//args can be parameters in algorthim such as threshold or theta?
+//Run on 5000 images.
+//Record success rates
+//All done with makefile
+
+
+//But first understand houghline transform
+//Know what the algorithm being used is doing.
+//MAke constants for this classifier
+//Make java be able to run on CMD line
+
+public class Main {
+
+    //GLOBAL_CONSTANTS
+    //SHOULD TURN INTO ARGS
+
+    private static  BufferedImage toBufferedImage(Mat mat){
+        //MOSTLY COPY PASTE!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+        //MOSTLY COPY PASTE!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+        //https://riptutorial.com/opencv/example/21963/converting-an-mat-object-to-an-bufferedimage-object
+        try{
+            int type = BufferedImage.TYPE_3BYTE_BGR;
+            int bufferSize = mat.channels() * mat.cols() * mat.rows();
+            byte[] b = new byte[bufferSize];
+            //get all the pixels
+            mat.get(0, 0, b);
+            BufferedImage image = new BufferedImage(mat.cols(), mat.rows(), type);
+            final byte[] targetPixels = ((DataBufferByte) image.getRaster().getDataBuffer()).getData();
+            System.arraycopy(b, 0, targetPixels, 0, b.length);
+            return image;
+        }
+        catch(Exception e){
+            System.err.println(e);
+        }
+        return null;
+    }
+
+    private static boolean Classifier(BufferedImage img){
+        try {
+            //Read file
+            //BufferedImage img = ImageIO.read(new File(processedFile));
+            int x = img.getWidth();
+            int y = img.getHeight();
+            int pixelCount  = 0;
+            int redCount    = 0;
+            float percentage = 0;
+
+            //Go Thru every pixel
+            for(int i=0; i < y; i++){
+                for(int j=0;j < x; j++){
+                    //Get value for current pixels RGB value
+                    int currPixelRGB = img.getRGB(j, i);
+                    //Check if pixel is red (hex value of red)
+                    if(currPixelRGB == 0xFFFF0000){
+                        redCount++;
+                    }
+                    pixelCount++;
+                }
+            }
+            //Calculate percentage of Red in image
+            percentage = ((float)redCount/(float)pixelCount)*(float)100;
+            //If more than %10 and less than %50 then its sheet music!
+            if(percentage > 10 && percentage < 50){ //MAKE THESE CONSTANTS!!
+                return true;}
+        }
+        catch (Exception e) {
+            System.err.println(e);
+        }
+        return false;
+    }
+
+    public static void main(String[] args) {
+        System.loadLibrary(Core.NATIVE_LIBRARY_NAME);
+        try {
+            //Variables
+            Mat edgesDetected = new Mat();
+            Mat edgesDetectedRGB = new Mat();
+            Mat forOTSU = new Mat();
+            Mat edgesDetectedRGBProb;
+            Mat justEdges; //TESTING
+            String default_file = "TestImages/houghlineTest.png";
+            String filename = ((args.length > 0) ? args[0] : default_file);
+
+            // Load an image
+            Mat original = Imgcodecs.imread(filename, Imgcodecs.IMREAD_GRAYSCALE);
+            // Edge detection
+            //01 CANNY
+            //Imgproc.Canny(original, edgesDetected, 50, 200, 3, false);
+            //02 BINARYINV
+            Imgproc.adaptiveThreshold(original, edgesDetected,255, Imgproc.ADAPTIVE_THRESH_GAUSSIAN_C,Imgproc.THRESH_BINARY_INV,15, 2);
+            //03 BINARY
+            //Imgproc.adaptiveThreshold(original, edgesDetected,255, Imgproc.ADAPTIVE_THRESH_GAUSSIAN_C,Imgproc.THRESH_BINARY,15, 2);
+            //04 NO PROC
+            //edgesDetected = original.clone();
+            //05 OTSU THRESHOLD
+            //Imgproc.threshold(original, edgesDetected,0,255,Imgproc.THRESH_BINARY_INV+Imgproc.THRESH_OTSU);
+
+
+
+            //Convert to RGB
+            Imgproc.cvtColor(edgesDetected, edgesDetectedRGB, Imgproc.COLOR_GRAY2BGR);
+            justEdges = edgesDetectedRGB.clone();//TESTING
+
+            // Standard Hough Line Transform
+            Mat lines = new Mat(); // will hold the results of the detection
+            //(edgeDetectedImage, outputOfDetection(r,Îž), resolution of rho, resolution of theta, threshold (minimum num of intersections)
+            Imgproc.HoughLines(edgesDetected, lines, 1, Math.PI / 180.0, 350); // runs the actual detection
+            //Imgproc.HoughLines(edgesDetected, lines, 5.0, 4.0, 7); // runs the actual detection
+
+            //make some test images. black and white. row of white row of black. call hough transform. check if its displaying as expected
+            //make sure res of 0 is appropriate, try 360
+            //expect theta values of 0+-
+            //try greyscale image
+
+
+            for (int i = 0; i < lines.cols(); i++) {
+                double rho = lines.get(0, i)[0];
+                double theta = lines.get(0, i)[1];
+                double cosTheta = Math.cos(theta);
+                double sinTheta = Math.sin(theta);
+                double x0 = cosTheta * rho;
+                double y0 = sinTheta * rho;
+                double xpt1 = x0 + 10000 * (-sinTheta);
+                double ypt1 = y0 + 10000 * (cosTheta);
+                double xpt2 = x0 - 10000 * (-sinTheta);
+                double ypt2 = y0 - 10000 * (cosTheta);
+                double angle = Core.fastAtan2((float)ypt2 - (float)ypt1, (float)xpt2 - (float)xpt1) * (Math.PI/180.0);
+                Point pt1 = new Point(xpt1, ypt1);
+                Point pt2 = new Point(xpt2, ypt2);
+                Imgproc.line(edgesDetectedRGB, pt1, pt2, new Scalar(0, 0, 255), 3, Imgproc.LINE_AA,0);
+                System.out.println("rho: " + rho + '\n' + "theta: " + theta + '\n' + "angle: " + angle);
+            }
+
+            /*
+            for (int x = 0; x < lines.rows(); x++) {
+                double rho = lines.get(x, 0)[0];
+                double theta = lines.get(x, 0)[1];
+                double cosTheta = Math.cos(theta);
+                double sinTheta = Math.sin(theta);                //CONVERT to Cartisean coord
+                double x0 = cosTheta * rho;
+                double y0 = sinTheta * rho;
+
+                double xpt1 = Math.round(x0 + 10000 * (-sinTheta));
+                double ypt1 = Math.round(y0 + 10000 * (cosTheta));
+                double xpt2 = Math.round(x0 - 10000 * (-sinTheta));
+                double ypt2 = Math.round(y0 - 10000 * (cosTheta));
+                double angle = Core.fastAtan2((float)ypt2 - (float)ypt1, (float)xpt2 - (float)xpt1) * (Math.PI/180.0);
+
+                Point pt1 = new Point(xpt1, ypt1);
+                Point pt2 = new Point(xpt2, ypt2);
+                Imgproc.line(edgesDetectedRGB, pt1, pt2, new Scalar(0, 0, 255), 3, Imgproc.LINE_AA, 0);
+
+                System.out.println("rho: " + rho + '\n' + "theta: " + theta + '\n' + "angle: " + angle);
+            }
+            */
+
+
+            //Display Results
+            //HighGui.imshow("Source", original);
+            HighGui.imshow("Just Edges", justEdges); //TESTING
+            HighGui.imshow("Detected Lines (in red) - Standard Hough Line Transform", edgesDetectedRGB);
+            //HighGui.imshow("Detected Lines (in red) - Probabilistic Line Transform", edgesDetectedRGBProb);
+
+            // Wait and Exit
+            HighGui.waitKey();
+            System.exit(0);
+        }
+        catch(Exception e){
+            System.err.println(e);
+        }
+    }
+}
